description: A liveness probe to check if a given instance can attend new requests
type: object
required:
- protocol
- frequency
- startupGraceWindow
- timeout
properties:
  protocol:
    description: The protocol used to access the probe
    type: object
    minProperties: 1
    maxProperties: 1
    properties:
      exec:
        $ref: './probeProtocolExec.yaml'
      http:
        $ref: './probeProtocolHttp.yaml'
      tcp:
        $ref: './probeProtocolTcp.yaml'
  frequency:
    description: How often the probe is executed
    oneOf:
    - description: Number of millis
      type: integer
      minimum: 1
    - description: A qualitative description of the frequenct
      type: string
      enum:
      - high
      - medium
      - low
  startupGraceWindow:
    description: Describes the maximum startup time required by this container to start receiving probe checks
    type: object
    required:
    - unit
    - duration
    - probe
    properties:
      unit:
        description: Which unit is used to describe the startup time (millis or attempts)
        type: string
        enum:
        - ms
        - attempts
      duration:
        description: The duration of the startup time considering the declared unit
        type: integer
        minimum: 1
      probe:
        description: If a specific sartup probe must be used or the startup must be calculated as a configuration parameter of readines and liveness probes
        type: boolean
  timeout:
    description: How much time the probe must keep failing to considere it actually failed
    type: integer
    minimum: 1